// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'json_baseline_builder.dart';

// **************************************************************************
// Generator: JsonWidgetLibraryBuilder
// **************************************************************************

// ignore_for_file: avoid_init_to_null
// ignore_for_file: deprecated_member_use

// ignore_for_file: prefer_const_constructors
// ignore_for_file: prefer_const_constructors_in_immutables
// ignore_for_file: prefer_final_locals
// ignore_for_file: prefer_if_null_operators
// ignore_for_file: prefer_single_quotes
// ignore_for_file: unused_local_variable

class JsonBaselineBuilder extends _JsonBaselineBuilder {
  const JsonBaselineBuilder({required super.args});

  static const kType = 'baseline';

  /// Constant that can be referenced for the builder's type.
  @override
  String get type => kType;

  /// Static function that is capable of decoding the widget from a dynamic JSON
  /// or YAML set of values.
  static JsonBaselineBuilder fromDynamic(
    dynamic map, {
    JsonWidgetRegistry? registry,
  }) =>
      JsonBaselineBuilder(
        args: map,
      );

  @override
  JsonBaselineBuilderModel createModel({
    ChildWidgetBuilder? childBuilder,
    required JsonWidgetData data,
  }) {
    final model = JsonBaselineBuilderModel.fromDynamic(
      args,
      registry: data.jsonWidgetRegistry,
    );

    return model;
  }

  @override
  Baseline buildCustom({
    ChildWidgetBuilder? childBuilder,
    required BuildContext context,
    required JsonWidgetData data,
    Key? key,
  }) {
    final model = createModel(
      childBuilder: childBuilder,
      data: data,
    );

    return Baseline(
      baseline: model.baseline,
      baselineType: model.baselineType,
      key: key,
      child: model.child?.build(
        childBuilder: childBuilder,
        context: context,
      ),
    );
  }
}

class JsonBaseline extends JsonWidgetData {
  JsonBaseline({
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
    required this.baseline,
    required this.baselineType,
    this.child,
  }) : super(
          jsonWidgetArgs: JsonBaselineBuilderModel.fromDynamic(
            {
              'baseline': baseline,
              'baselineType': baselineType,
              'child': child,
              ...args,
            },
            args: args,
            registry: registry,
          ),
          jsonWidgetBuilder: () => JsonBaselineBuilder(
            args: JsonBaselineBuilderModel.fromDynamic(
              {
                'baseline': baseline,
                'baselineType': baselineType,
                'child': child,
                ...args,
              },
              args: args,
              registry: registry,
            ),
          ),
          jsonWidgetType: JsonBaselineBuilder.kType,
        );

  /* AUTOGENERATED FROM [Baseline.baseline]*/
  /// The number of logical pixels from the top of this box at which to position
  /// the child's baseline.
  final double baseline;

  /* AUTOGENERATED FROM [Baseline.baselineType]*/
  /// The type of baseline to use for positioning the child.
  final TextBaseline baselineType;

  final JsonWidgetData? child;
}

/* AUTOGENERATED FROM [Baseline]*/
/// Creates a widget that positions its child according to the child's baseline.
class JsonBaselineBuilderModel extends JsonWidgetBuilderModel {
  const JsonBaselineBuilderModel(
    super.args, {
    required this.baseline,
    required this.baselineType,
    this.child,
  });

  /* AUTOGENERATED FROM [Baseline.baseline]*/
  /// The number of logical pixels from the top of this box at which to position
  /// the child's baseline.
  final double baseline;

  /* AUTOGENERATED FROM [Baseline.baselineType]*/
  /// The type of baseline to use for positioning the child.
  final TextBaseline baselineType;

  final JsonWidgetData? child;

  static JsonBaselineBuilderModel fromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    final result = maybeFromDynamic(
      map,
      args: args,
      registry: registry,
    );

    if (result == null) {
      throw Exception(
        '[JsonBaselineBuilder]: requested to parse from dynamic, but the input is null.',
      );
    }

    return result;
  }

  static JsonBaselineBuilderModel? maybeFromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    JsonBaselineBuilderModel? result;

    if (map != null) {
      if (map is String) {
        map = yaon.parse(
          map,
          normalize: true,
        );
      }

      if (map is JsonBaselineBuilderModel) {
        result = map;
      } else {
        registry ??= JsonWidgetRegistry.instance;
        map = registry.processArgs(map, <String>{}).value;
        result = JsonBaselineBuilderModel(
          args,
          baseline: () {
            dynamic parsed = JsonClass.parseDouble(map['baseline']);

            if (parsed == null) {
              throw Exception(
                'Null value encountered for required parameter: [baseline].',
              );
            }
            return parsed;
          }(),
          baselineType: () {
            dynamic parsed = ThemeDecoder.decodeTextBaseline(
              map['baselineType'],
              validate: false,
            );

            if (parsed == null) {
              throw Exception(
                'Null value encountered for required parameter: [baselineType].',
              );
            }
            return parsed;
          }(),
          child: () {
            dynamic parsed = JsonWidgetData.maybeFromDynamic(
              map['child'],
              registry: registry,
            );

            return parsed;
          }(),
        );
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toJson() {
    return JsonClass.removeNull({
      'baseline': baseline,
      'baselineType': ThemeEncoder.encodeTextBaseline(
        baselineType,
      ),
      'child': child?.toJson(),
      ...args,
    });
  }
}

class BaselineSchema {
  static const id =
      'https://peiffer-innovations.github.io/flutter_json_schemas/schemas/json_dynamic_widget/baseline.json';

  static final schema = <String, Object>{
    r'$schema': 'http://json-schema.org/draft-07/schema#',
    r'$id': id,
    'title': 'Baseline',
    'type': 'object',
    'additionalProperties': false,
    'properties': {
      'baseline': SchemaHelper.numberSchema,
      'baselineType': SchemaHelper.objectSchema(TextBaselineSchema.id),
      'child': SchemaHelper.objectSchema(JsonWidgetDataSchema.id),
    },
  };
}
