// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'json_container_builder.dart';

// **************************************************************************
// Generator: JsonWidgetLibraryBuilder
// **************************************************************************

// ignore_for_file: avoid_init_to_null
// ignore_for_file: deprecated_member_use

// ignore_for_file: prefer_const_constructors
// ignore_for_file: prefer_const_constructors_in_immutables
// ignore_for_file: prefer_final_locals
// ignore_for_file: prefer_if_null_operators
// ignore_for_file: prefer_single_quotes
// ignore_for_file: unused_local_variable

class JsonContainerBuilder extends _JsonContainerBuilder {
  const JsonContainerBuilder({required super.args});

  static const kType = 'container';

  /// Constant that can be referenced for the builder's type.
  @override
  String get type => kType;

  /// Static function that is capable of decoding the widget from a dynamic JSON
  /// or YAML set of values.
  static JsonContainerBuilder fromDynamic(
    dynamic map, {
    JsonWidgetRegistry? registry,
  }) =>
      JsonContainerBuilder(
        args: map,
      );

  @override
  JsonContainerBuilderModel createModel({
    ChildWidgetBuilder? childBuilder,
    required JsonWidgetData data,
  }) {
    final model = JsonContainerBuilderModel.fromDynamic(
      args,
      registry: data.jsonWidgetRegistry,
    );

    return model;
  }

  @override
  Container buildCustom({
    ChildWidgetBuilder? childBuilder,
    required BuildContext context,
    required JsonWidgetData data,
    Key? key,
  }) {
    final model = createModel(
      childBuilder: childBuilder,
      data: data,
    );

    final decorationDecoded = _decodeDecoration(
      value: model.decoration,
    );
    final foregroundDecorationDecoded = _decodeForegroundDecoration(
      value: model.foregroundDecoration,
    );

    return Container(
      alignment: model.alignment,
      clipBehavior: model.clipBehavior,
      color: model.color,
      constraints: model.constraints,
      decoration: decorationDecoded,
      foregroundDecoration: foregroundDecorationDecoded,
      height: model.height,
      key: key,
      margin: model.margin,
      padding: model.padding,
      transform: model.transform,
      transformAlignment: model.transformAlignment,
      width: model.width,
      child: model.child?.build(
        childBuilder: childBuilder,
        context: context,
      ),
    );
  }
}

class JsonContainer extends JsonWidgetData {
  JsonContainer({
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
    this.alignment,
    this.clipBehavior = Clip.none,
    this.color,
    this.constraints,
    required this.decoration,
    required this.foregroundDecoration,
    this.height,
    this.margin,
    this.padding,
    this.transform,
    this.transformAlignment,
    this.width,
    this.child,
  }) : super(
          jsonWidgetArgs: JsonContainerBuilderModel.fromDynamic(
            {
              'alignment': alignment,
              'clipBehavior': clipBehavior,
              'color': color,
              'constraints': constraints,
              'decoration': decoration,
              'foregroundDecoration': foregroundDecoration,
              'height': height,
              'margin': margin,
              'padding': padding,
              'transform': transform,
              'transformAlignment': transformAlignment,
              'width': width,
              'child': child,
              ...args,
            },
            args: args,
            registry: registry,
          ),
          jsonWidgetBuilder: () => JsonContainerBuilder(
            args: JsonContainerBuilderModel.fromDynamic(
              {
                'alignment': alignment,
                'clipBehavior': clipBehavior,
                'color': color,
                'constraints': constraints,
                'decoration': decoration,
                'foregroundDecoration': foregroundDecoration,
                'height': height,
                'margin': margin,
                'padding': padding,
                'transform': transform,
                'transformAlignment': transformAlignment,
                'width': width,
                'child': child,
                ...args,
              },
              args: args,
              registry: registry,
            ),
          ),
          jsonWidgetType: JsonContainerBuilder.kType,
        );

  /* AUTOGENERATED FROM [Container.alignment]*/
  /// Align the [child] within the container.
  ///
  /// If non-null, the container will expand to fill its parent and position its
  /// child within itself according to the given value. If the incoming
  /// constraints are unbounded, then the child will be shrink-wrapped instead.
  ///
  /// Ignored if [child] is null.
  ///
  /// See also:
  ///
  ///  * [Alignment], a class with convenient constants typically used to
  ///    specify an [AlignmentGeometry].
  ///  * [AlignmentDirectional], like [Alignment] for specifying alignments
  ///    relative to text direction.
  final AlignmentGeometry? alignment;

  /* AUTOGENERATED FROM [Container.clipBehavior]*/
  /// The clip behavior when [Container.decoration] is not null.
  ///
  /// Defaults to [Clip.none]. Must be [Clip.none] if [decoration] is null.
  ///
  /// If a clip is to be applied, the [Decoration.getClipPath] method
  /// for the provided decoration must return a clip path. (This is not
  /// supported by all decorations; the default implementation of that
  /// method throws an [UnsupportedError].)
  final Clip clipBehavior;

  /* AUTOGENERATED FROM [Container.color]*/
  /// The color to paint behind the [child].
  ///
  /// This property should be preferred when the background is a simple color.
  /// For other cases, such as gradients or images, use the [decoration]
  /// property.
  ///
  /// If the [decoration] is used, this property must be null. A background
  /// color may still be painted by the [decoration] even if this property is
  /// null.
  final Color? color;

  /* AUTOGENERATED FROM [Container.constraints]*/
  /// Additional constraints to apply to the child.
  ///
  /// The constructor `width` and `height` arguments are combined with the
  /// `constraints` argument to set this property.
  ///
  /// The [padding] goes inside the constraints.
  final BoxConstraints? constraints;

  /* AUTOGENERATED FROM [Container.decoration]*/
  /// The decoration to paint behind the [child].
  ///
  /// Use the [color] property to specify a simple solid color.
  ///
  /// The [child] is not clipped to the decoration. To clip a child to the shape
  /// of a particular [ShapeDecoration], consider using a [ClipPath] widget.
  final dynamic decoration;

  /* AUTOGENERATED FROM [Container.foregroundDecoration]*/
  /// The decoration to paint in front of the [child].
  final dynamic foregroundDecoration;

  final double? height;

  /* AUTOGENERATED FROM [Container.margin]*/
  /// Empty space to surround the [decoration] and [child].
  final EdgeInsetsGeometry? margin;

  /* AUTOGENERATED FROM [Container.padding]*/
  /// Empty space to inscribe inside the [decoration]. The [child], if any, is
  /// placed inside this padding.
  ///
  /// This padding is in addition to any padding inherent in the [decoration];
  /// see [Decoration.padding].
  final EdgeInsetsGeometry? padding;

  /* AUTOGENERATED FROM [Container.transform]*/
  /// The transformation matrix to apply before painting the container.
  final Matrix4? transform;

  /* AUTOGENERATED FROM [Container.transformAlignment]*/
  /// The alignment of the origin, relative to the size of the container, if [transform] is specified.
  ///
  /// When [transform] is null, the value of this property is ignored.
  ///
  /// See also:
  ///
  ///  * [Transform.alignment], which is set by this property.
  final AlignmentGeometry? transformAlignment;

  final double? width;

  /* AUTOGENERATED FROM [Container.child]*/
  /// The [child] contained by the container.
  ///
  /// If null, and if the [constraints] are unbounded or also null, the
  /// container will expand to fill all available space in its parent, unless
  /// the parent provides unbounded constraints, in which case the container
  /// will attempt to be as small as possible.
  ///
  /// {@macro flutter.widgets.ProxyWidget.child}
  final JsonWidgetData? child;
}

/* AUTOGENERATED FROM [Container]*/
/// Creates a widget that combines common painting, positioning, and sizing widgets.
///
/// The `height` and `width` values include the padding.
///
/// The `color` and `decoration` arguments cannot both be supplied, since
/// it would potentially result in the decoration drawing over the background
/// color. To supply a decoration with a color, use `decoration:
/// BoxDecoration(color: color)`.
class JsonContainerBuilderModel extends JsonWidgetBuilderModel {
  const JsonContainerBuilderModel(
    super.args, {
    this.alignment,
    this.clipBehavior = Clip.none,
    this.color,
    this.constraints,
    required this.decoration,
    required this.foregroundDecoration,
    this.height,
    this.margin,
    this.padding,
    this.transform,
    this.transformAlignment,
    this.width,
    this.child,
  });

  /* AUTOGENERATED FROM [Container.alignment]*/
  /// Align the [child] within the container.
  ///
  /// If non-null, the container will expand to fill its parent and position its
  /// child within itself according to the given value. If the incoming
  /// constraints are unbounded, then the child will be shrink-wrapped instead.
  ///
  /// Ignored if [child] is null.
  ///
  /// See also:
  ///
  ///  * [Alignment], a class with convenient constants typically used to
  ///    specify an [AlignmentGeometry].
  ///  * [AlignmentDirectional], like [Alignment] for specifying alignments
  ///    relative to text direction.
  final AlignmentGeometry? alignment;

  /* AUTOGENERATED FROM [Container.clipBehavior]*/
  /// The clip behavior when [Container.decoration] is not null.
  ///
  /// Defaults to [Clip.none]. Must be [Clip.none] if [decoration] is null.
  ///
  /// If a clip is to be applied, the [Decoration.getClipPath] method
  /// for the provided decoration must return a clip path. (This is not
  /// supported by all decorations; the default implementation of that
  /// method throws an [UnsupportedError].)
  final Clip clipBehavior;

  /* AUTOGENERATED FROM [Container.color]*/
  /// The color to paint behind the [child].
  ///
  /// This property should be preferred when the background is a simple color.
  /// For other cases, such as gradients or images, use the [decoration]
  /// property.
  ///
  /// If the [decoration] is used, this property must be null. A background
  /// color may still be painted by the [decoration] even if this property is
  /// null.
  final Color? color;

  /* AUTOGENERATED FROM [Container.constraints]*/
  /// Additional constraints to apply to the child.
  ///
  /// The constructor `width` and `height` arguments are combined with the
  /// `constraints` argument to set this property.
  ///
  /// The [padding] goes inside the constraints.
  final BoxConstraints? constraints;

  /* AUTOGENERATED FROM [Container.decoration]*/
  /// The decoration to paint behind the [child].
  ///
  /// Use the [color] property to specify a simple solid color.
  ///
  /// The [child] is not clipped to the decoration. To clip a child to the shape
  /// of a particular [ShapeDecoration], consider using a [ClipPath] widget.
  final dynamic decoration;

  /* AUTOGENERATED FROM [Container.foregroundDecoration]*/
  /// The decoration to paint in front of the [child].
  final dynamic foregroundDecoration;

  final double? height;

  /* AUTOGENERATED FROM [Container.margin]*/
  /// Empty space to surround the [decoration] and [child].
  final EdgeInsetsGeometry? margin;

  /* AUTOGENERATED FROM [Container.padding]*/
  /// Empty space to inscribe inside the [decoration]. The [child], if any, is
  /// placed inside this padding.
  ///
  /// This padding is in addition to any padding inherent in the [decoration];
  /// see [Decoration.padding].
  final EdgeInsetsGeometry? padding;

  /* AUTOGENERATED FROM [Container.transform]*/
  /// The transformation matrix to apply before painting the container.
  final Matrix4? transform;

  /* AUTOGENERATED FROM [Container.transformAlignment]*/
  /// The alignment of the origin, relative to the size of the container, if [transform] is specified.
  ///
  /// When [transform] is null, the value of this property is ignored.
  ///
  /// See also:
  ///
  ///  * [Transform.alignment], which is set by this property.
  final AlignmentGeometry? transformAlignment;

  final double? width;

  /* AUTOGENERATED FROM [Container.child]*/
  /// The [child] contained by the container.
  ///
  /// If null, and if the [constraints] are unbounded or also null, the
  /// container will expand to fill all available space in its parent, unless
  /// the parent provides unbounded constraints, in which case the container
  /// will attempt to be as small as possible.
  ///
  /// {@macro flutter.widgets.ProxyWidget.child}
  final JsonWidgetData? child;

  static JsonContainerBuilderModel fromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    final result = maybeFromDynamic(
      map,
      args: args,
      registry: registry,
    );

    if (result == null) {
      throw Exception(
        '[JsonContainerBuilder]: requested to parse from dynamic, but the input is null.',
      );
    }

    return result;
  }

  static JsonContainerBuilderModel? maybeFromDynamic(
    dynamic map, {
    Map<String, dynamic> args = const {},
    JsonWidgetRegistry? registry,
  }) {
    JsonContainerBuilderModel? result;

    if (map != null) {
      if (map is String) {
        map = yaon.parse(
          map,
          normalize: true,
        );
      }

      if (map is JsonContainerBuilderModel) {
        result = map;
      } else {
        registry ??= JsonWidgetRegistry.instance;
        map = registry.processArgs(map, <String>{}).value;
        result = JsonContainerBuilderModel(
          args,
          alignment: () {
            dynamic parsed = ThemeDecoder.decodeAlignmentGeometry(
              map['alignment'],
              validate: false,
            );

            return parsed;
          }(),
          clipBehavior: () {
            dynamic parsed = ThemeDecoder.decodeClip(
              map['clipBehavior'],
              validate: false,
            );
            parsed ??= Clip.none;

            return parsed;
          }(),
          color: () {
            dynamic parsed = ThemeDecoder.decodeColor(
              map['color'],
              validate: false,
            );

            return parsed;
          }(),
          constraints: () {
            dynamic parsed = ThemeDecoder.decodeBoxConstraints(
              map['constraints'],
              validate: false,
            );

            return parsed;
          }(),
          decoration: map['decoration'],
          foregroundDecoration: map['foregroundDecoration'],
          height: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['height']);

            return parsed;
          }(),
          margin: () {
            dynamic parsed = ThemeDecoder.decodeEdgeInsetsGeometry(
              map['margin'],
              validate: false,
            );

            return parsed;
          }(),
          padding: () {
            dynamic parsed = ThemeDecoder.decodeEdgeInsetsGeometry(
              map['padding'],
              validate: false,
            );

            return parsed;
          }(),
          transform: () {
            dynamic parsed = ThemeDecoder.decodeMatrix4(
              map['transform'],
              validate: false,
            );

            return parsed;
          }(),
          transformAlignment: () {
            dynamic parsed = ThemeDecoder.decodeAlignmentGeometry(
              map['transformAlignment'],
              validate: false,
            );

            return parsed;
          }(),
          width: () {
            dynamic parsed = JsonClass.maybeParseDouble(map['width']);

            return parsed;
          }(),
          child: () {
            dynamic parsed = JsonWidgetData.maybeFromDynamic(
              map['child'],
              registry: registry,
            );

            return parsed;
          }(),
        );
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toJson() {
    final decorationEncoded =
        _JsonContainerBuilder._encodeDecoration(decoration);
    final foregroundDecorationEncoded =
        _JsonContainerBuilder._encodeForegroundDecoration(foregroundDecoration);

    return JsonClass.removeNull({
      'alignment': ThemeEncoder.encodeAlignmentGeometry(
        alignment,
      ),
      'clipBehavior': Clip.none == clipBehavior
          ? null
          : ThemeEncoder.encodeClip(
              clipBehavior,
            ),
      'color': ThemeEncoder.encodeColor(
        color,
      ),
      'constraints': ThemeEncoder.encodeBoxConstraints(
        constraints,
      ),
      'decoration': decorationEncoded,
      'foregroundDecoration': foregroundDecorationEncoded,
      'height': height,
      'margin': ThemeEncoder.encodeEdgeInsetsGeometry(
        margin,
      ),
      'padding': ThemeEncoder.encodeEdgeInsetsGeometry(
        padding,
      ),
      'transform': ThemeEncoder.encodeMatrix4(
        transform,
      ),
      'transformAlignment': ThemeEncoder.encodeAlignmentGeometry(
        transformAlignment,
      ),
      'width': width,
      'child': child?.toJson(),
      ...args,
    });
  }
}

class ContainerSchema {
  static const id =
      'https://peiffer-innovations.github.io/flutter_json_schemas/schemas/json_dynamic_widget/container.json';

  static final schema = <String, Object>{
    r'$schema': 'http://json-schema.org/draft-07/schema#',
    r'$id': id,
    'title': 'Container',
    'type': 'object',
    'additionalProperties': false,
    'properties': {
      'alignment': SchemaHelper.objectSchema(AlignmentGeometrySchema.id),
      'clipBehavior': SchemaHelper.objectSchema(ClipSchema.id),
      'color': SchemaHelper.objectSchema(ColorSchema.id),
      'constraints': SchemaHelper.objectSchema(BoxConstraintsSchema.id),
      'decoration': _JsonContainerBuilder._decorationSchema(),
      'foregroundDecoration':
          _JsonContainerBuilder._foregroundDecorationSchema(),
      'height': SchemaHelper.numberSchema,
      'margin': SchemaHelper.objectSchema(EdgeInsetsGeometrySchema.id),
      'padding': SchemaHelper.objectSchema(EdgeInsetsGeometrySchema.id),
      'transform': SchemaHelper.objectSchema(Matrix4Schema.id),
      'transformAlignment':
          SchemaHelper.objectSchema(AlignmentGeometrySchema.id),
      'width': SchemaHelper.numberSchema,
      'child': SchemaHelper.objectSchema(JsonWidgetDataSchema.id),
    },
  };
}
